<template>
  <div />
</template>

<script>
import * as d3 from "d3";

export default {
  name: "HorizontalBarChart",

  data() {
    return {
      data: [
        {
          name: "10 años",
          value: 10,
        },
        {
          name: "7 años",
          value: 7,
        },
        {
          name: "6 años",
          value: 6,
        },
        {
          name: "5 años",
          value: 5,
        },
        {
          name: "2 años",
          value: 2,
        },
      ],
      labels: [],
      width: 100,
      height: 100,
      colorScale: ["#4A148C", "#DCC5F4"],
    };
  },

  mounted() {
    this.render();
  },

  methods: {
    render() {
      const margin = { top: 30, right: 0, bottom: 30, left: 40 };

      const yAxis = (g) =>
        g.attr("transform", `translate(${margin.left},0)`).call(
          d3
            .axisLeft(y)
            .tickFormat((i) => this.data[i].name)
            .tickSizeOuter(0)
        );

      const xAxis = (g) =>
        g
          .attr("transform", `translate(0,${margin.top})`)
          .call(d3.axisTop(x).ticks(this.width / 80, this.data.format))
          .call((g) => g.select(".domain").remove());

      const y = d3
        .scaleBand()
        .domain(d3.range(this.data.length))
        .rangeRound([margin.top, this.height - margin.bottom])
        .padding(0.1);

      const x = d3
        .scaleLinear()
        .domain([0, d3.max(this.data, (d) => d.value)])
        .range([margin.left, this.width - margin.right]);

      const format = x.tickFormat(20, this.data.format);

      const svg = d3
        .select(this.$el)
        .append("svg")
        .attr("viewBox", [0, 0, this.width, this.height])
        .attr("font-size", 10)
        .attr("font-family", "sans-serif")
        .attr("text-anchor", "middle");

      svg
        .append("g")
        .attr("fill", "steelblue")
        .selectAll("rect")
        .data(this.data)
        .join("rect")
        .attr("x", x(0))
        .attr("y", (d, i) => y(i))
        .attr("width", (d) => x(d.value) - x(0))
        .attr("height", y.bandwidth());

      svg
        .append("g")
        .attr("fill", "white")
        .attr("text-anchor", "end")
        .attr("font-family", "sans-serif")
        .attr("font-size", 12)
        .selectAll("text")
        .data(this.data)
        .join("text")
        .attr("x", (d) => x(d.value))
        .attr("y", (d, i) => y(i) + y.bandwidth() / 2)
        .attr("dy", "0.35em")
        .attr("dx", -4)
        .text((d) => format(d.value))
        .call((text) =>
          text
            .filter((d) => x(d.value) - x(0) < 20) // short bars
            .attr("dx", +4)
            .attr("fill", "black")
            .attr("text-anchor", "start")
        );

      svg.append("g").call(xAxis);

      svg.append("g").call(yAxis);

      return svg.node();
    },
  },
};
</script>
